import sys
import time
import mysql.connector as mariadb
import datetime


import Adafruit_DHT


# Parse command line parameters.
sensor_args = { '11': Adafruit_DHT.DHT11,
                '22': Adafruit_DHT.DHT22,
                '2302': Adafruit_DHT.AM2302 }

sensor=Adafruit_DHT.DHT22
pin = 4

while True:
    # Try to grab a sensor reading.  Use the read_retry method which will retry up
    # to 15 times to get a sensor reading (waiting 2 seconds between each retry).
    humidity, temperature = Adafruit_DHT.read_retry(sensor, pin)

    # Un-comment the line below to convert the temperature to Fahrenheit.
    # temperature = temperature * 9/5.0 + 32

    # Note that sometimes you won't get a reading and
    # the results will be null (because Linux can't
    # guarantee the timing of calls to read the sensor).
    # If this happens try again!
    if humidity is not None and temperature is not None:
        print('Temp={0:0.1f}*  Humidity={1:0.1f}%'.format(temperature, humidity))
        temperature = '{0:0.1f} °C'.format(temperature)
    else:
        print('Failed to get reading. Try again!')
        sys.exit(1)

    time.sleep(2)
    date = datetime.date.today()
    hour = datetime.datetime.now().time()

    conn = mariadb.connect(database='project1', user='project1-sensor', password='sensorpassword')
    cursor = conn.cursor()
    cursor.execute("INSERT INTO project1.Home_X_Sensoren (Meting,Datum,Uur, HuisId, SensorNr) VALUES (%s, %s, %s, %s, %s)", (temperature,date,hour, 1, 1))
    conn.commit()

