import logging
import signal
import subprocess
import time
from time import sleep
import sys
import mysql.connector as mariadb
import datetime
import grovepi
import Adafruit_DHT
from RPi import GPIO

log = logging.getLogger(__name__)

running = True

GPIO.setmode(GPIO.BCM)

GPIO.setwarnings(False)

GPIO.setup(18, GPIO.OUT)

p = GPIO.PWM(18, 50)

p.start(6)

try:
    def SetAngle(angle):
        duty = angle / 18 + 2
        GPIO.output(18, True)
        p.ChangeDutyCycle(duty)
        sleep(1)
        GPIO.output(18, False)
        p.ChangeDutyCycle(0)

except KeyboardInterrupt:
    p.stop()
    GPIO.cleanup()



def setup():
    def shutdown(*args):
        global running
        running = False
        # try:
        #     sys.exit(0)
        # except KeyError as ex:
        #     pass

    signal.signal(signal.SIGTERM, shutdown)


def loop():
    count = subprocess.check_output("/bin/ps aux | wc -l", shell=True)

    #---- Temp ------------------------------------------------------------------------

    # Parse command line parameters.
    sensor_args = {'11': Adafruit_DHT.DHT11,
                   '22': Adafruit_DHT.DHT22,
                   '2302': Adafruit_DHT.AM2302}

    sensor = Adafruit_DHT.DHT22
    pin = 4


    global temperature
    humidity, temperature = Adafruit_DHT.read_retry(sensor, pin)


    if humidity is not None and temperature is not None:
            print('Temp={0:0.1f}*  Humidity={1:0.1f}%'.format(temperature, humidity))
            temperatuur = '{0:0.1f} °C'.format(temperature)
    else:
            print('Failed to get reading. Try again!')
            sys.exit(1)

    time.sleep(2)
    date = datetime.date.today()
    hour = datetime.datetime.now().time()

    conn = mariadb.connect(database='project1', user='project1-sensor', password='sensorpassword')
    cursor = conn.cursor()
    cursor.execute(
            "INSERT INTO project1.Home_X_Sensoren (Meting,Datum,Uur, HuisId, SensorNr) VALUES (%s, %s, %s, %s, %s)",
            (temperatuur, date, hour, 1, 1))
    conn.commit()
    time.sleep(1)


    #----- Gas -----

    gas_sensor = 1

    grovepi.pinMode(gas_sensor, "INPUT")


    try:
            global gas
            gas = grovepi.analogRead(gas_sensor)

            # Hoge density betekent dikker gas.
            density = (float)(gas / 1024)

            print("gas: ", gas, " density: ", density)
            if gas > 260:
                g = str(gas)
                g = "Smoke detected"
            else:
                g = str(gas)
                g = "No smoke detected"

            time.sleep(.5)

    except IOError:
            print("Error")

    time.sleep(2)
    date = datetime.date.today()
    hour = datetime.datetime.now().time()

    conn = mariadb.connect(database='project1', user='project1-sensor', password='sensorpassword')
    cursor = conn.cursor()
    cursor.execute(
            "INSERT INTO project1.Home_X_Sensoren (Meting,Datum,Uur, HuisId, SensorNr) VALUES (%s, %s, %s, %s, %s)",
            (g, date, hour, 1, 2))
    conn.commit()
    time.sleep(1)

    #---Luchtkwaliteit-------

    air_sensor = 0

    grovepi.pinMode(air_sensor, "INPUT")



    try:
            # Get sensor value
            global air_sensor_value
            air_sensor_value = grovepi.analogRead(air_sensor)

            if air_sensor_value > 700:
                print("High pollution")
                a = "High pollution"
            elif air_sensor_value > 300:
                print("Low pollution")
                a = "Low pollution"
            else:
                print("Air fresh")
                a = "Air fresh"

            print("air =", air_sensor_value)
            time.sleep(.5)

    except IOError:
            print("Error")

    time.sleep(2)
    date = datetime.date.today()
    hour = datetime.datetime.now().time()

    conn = mariadb.connect(database='project1', user='project1-sensor', password='sensorpassword')
    cursor = conn.cursor()
    cursor.execute(
            "INSERT INTO project1.Home_X_Sensoren (Meting,Datum,Uur, HuisId, SensorNr) VALUES (%s, %s, %s, %s, %s)",
            (a, date, hour, 1, 3))
    conn.commit()
    time.sleep(1)

    # --------------------------------
def servo():

        GPIO.setup(23, GPIO.OUT)
        if air_sensor_value > 400 or temperature > 25:
            SetAngle(90)
            angle = 90
        else:
            SetAngle(0)
            angle = 0

        if gas > 260:
            GPIO.output(23, GPIO.HIGH)
        else:
            GPIO.output(23, GPIO.LOW)

        date = datetime.date.today()
        hour = datetime.datetime.now().time()

        conn = mariadb.connect(database='project1', user='project1-sensor', password='sensorpassword')
        cursor = conn.cursor()
        cursor.execute(
            "INSERT INTO project1.Home_X_Sensoren (Meting,Datum,Uur, HuisId, SensorNr) VALUES (%s, %s, %s, %s, %s)",
            (angle, date, hour, 1, 4))
        conn.commit()
        time.sleep(1)








if __name__ == '__main__':
    logging.basicConfig(level=logging.DEBUG)
    try:
        setup()
        while running:
            loop()
            servo()
    except KeyboardInterrupt:
        pass
