from flask import Flask, redirect, url_for, render_template, request, make_response
from flaskext.mysql import MySQL
from passlib.hash import argon2
from flask import session
import os

app = Flask(__name__)
app.secret_key = os.urandom(69)
mysql = MySQL(app)

# MySQL configurations
app.config["MYSQL_DATABASE_HOST"] = "localhost"
app.config["MYSQL_DATABASE_DB"] = "project1"
app.config["MYSQL_DATABASE_USER"] = "project1-admin"
app.config["MYSQL_DATABASE_PASSWORD"] = "tibo"


def get_data(sql, params=None):
    conn = mysql.connect()
    cursor = conn.cursor()
    print("getting data")
    try:
        print(sql)
        cursor.execute(sql, params)
    except Exception as e:
        print(e)
        return False

    result = cursor.fetchall()
    data = []
    for row in result:
        data.append(list(row))
    cursor.close()
    conn.close()

    return data


def set_data(sql, params=None):
    conn = mysql.connect()
    cursor = conn.cursor()
    print("Setting Data")
    # try:
    print(sql)
    cursor.execute(sql, params)
    conn.commit()
    # except Exception as e:
    # print(e)
    # return False

    # result = cursor.fetchall()
    # data = []
    # for row in result:
    # data.append(list(row))
    data = "Done"
    cursor.close()
    conn.close()

    return data

def isUserLoggedIn():
    if 'loggedin' in session:
        return True
    else:
        redirect('/login')


@app.route("/")
def index():
    if isUserLoggedIn():
        temp = get_data("select Meting from Home_X_Sensoren inner join Sensoren on Sensoren.SensorNr = Home_X_Sensoren.SensorNr where type like 'Temperatuur' group by Uur desc, Type asc limit 1;")
        lucht = get_data("select Meting from Home_X_Sensoren inner join Sensoren on Sensoren.SensorNr = Home_X_Sensoren.SensorNr where type like 'Luchtkwaliteit' group by Uur desc, Type asc limit 1;")
        gas = get_data("select Meting from Home_X_Sensoren inner join Sensoren on Sensoren.SensorNr = Home_X_Sensoren.SensorNr where type like 'Gas' group by Uur desc, Type asc limit 1;")
        servo = get_data("select Meting from Home_X_Sensoren inner join Sensoren on Sensoren.SensorNr = Home_X_Sensoren.SensorNr where type like 'Servo' group by Uur desc, Type asc limit 1;")

        return render_template("index.html", temp=temp, lucht=lucht, gas=gas, servo=servo)
    return render_template("login.html")





@app.route('/sensoren/')
def sensoren():
    if isUserLoggedIn():
        title_list = get_data("SHOW COLUMNS FROM " + "project1.Home_X_Sensoren")

        sensoren_list = get_data("select Type, Meting, Datum, Uur from " + "project1.Home_X_Sensoren inner join"
                                " project1.Sensoren on project1.Sensoren.SensorNr = project1.Home_X_Sensoren.SensorNr group by Uur desc, Type asc limit 4;")

        return render_template("sensoren.html", title_list=title_list,sensoren_list=sensoren_list)
    else:
        return render_template("login.html")



def userexists(u, p):
    try:
        cursor = mysql.connect().cursor()
        cursor.execute("SELECT * from project1.Gebruikers where GebruikersNaam = BINARY %s and Passwoord = BINARY %s;", (u, p))
        data = cursor.fetchall()
    finally:
        cursor.close()
        if len(data) > 0:
            return True
        return False

@app.route('/login', methods=['GET', 'POST'])
def login():
    if request.method == 'POST':
        password = request.form.get('password')
        user = request.form.get('username')
        record = get_data("SELECT Passwoord from project1.Gebruikers WHERE GebruikersNaam = %s;", (user, ))


        if not record:
            return render_template("login.html", User=True)
        else:

            authorized = argon2.verify(password, record[0][0])

            if authorized:
                    session["loggedin"] = 1
                    return redirect("/")
            else:
                return render_template("login.html", Warning=True)

    else:
        return render_template("login.html", Warning=True)


@app.route('/register', methods=['GET', 'POST'])
def register():
    if request.method == 'POST':
        user = request.form.get('username')
        password = request.form.get('password')
        huis = request.form.get('huis')
        if not userexists(user, password):
            try:
                connection = mysql.connect()
                cursor = connection.cursor()
                pw_hash = argon2.hash(password)
                cursor.execute(
                    "INSERT INTO `Gebruikers`(`GebruikersNaam`, `Passwoord`, `HuisId`) VALUES (%s,%s,%s);", (user, pw_hash, 1))
                connection.commit()
            except Exception as e:
                return str(e)
            finally:
                cursor.close()
            return render_template("login.html")
        return render_template("registreer.html", UserExists=True)
    return render_template("registreer.html")


@app.route('/logout')
def logout():
    if isUserLoggedIn():
        session.pop('loggedin')
        return render_template("login.html")
    else:
        return render_template("login.html")

@app.errorhandler(404)
def page_not_found_404():
    return render_template('error.html'), 404

@app.errorhandler(500)
def internal_server_error_500():
    return render_template('error.html'), 500

@app.errorhandler(502)
def bad_gateway_502():
    return render_template('error.html'), 502


if __name__ == "__main__":
    app.run(host="0.0.0.0", debug=True)
